<!-- #include file="../Includes/Request_Start.inc.asp" -->
<script runat="server" language="vbscript" src="../Includes/categories.vbs"></script>
<script runat="server" language="vbscript" src="../Includes/helperFunctions.vbs"></script>
<script runat="server" language="jscript" src="../Includes/dataGrid2.js"></script>
<script runat="server" language="vbscript" src="../Includes/userRoles.vbs"></script>
<script runat="server" language="vbscript" src="../Includes/CheckHeader.vbs"></script>
<script runat="server" language="jscript" src="../Includes/urlEncoding.js"></script>
<script runat="server" language="jscript">
    function CreateDataGrid(Conn, Srch) {
        var dg = new DataGrid(
            Conn.Execute(
                "SELECT " +
                "  [Game ID]" +
                " ,[Title]" +
                " ,[Username]" +
                " ,[Category] = [Category ID]" +
                " ,[M] = ISNULL([Maturity Level Id],'-')" +
                " ,[D] = ISNULL([Difficulty Level Id],'-')" +
                " ,[F] = CASE WHEN [Date Category Featured] IS NULL THEN 'N' ELSE 'Y' END" +
                " ,[P] = CASE WHEN [Date Published] IS NULL THEN 'N' ELSE 'Y' END" +
                " ,[C] = (SELECT COUNT(*) FROM [Game Pages] WHERE [Game ID]=Games.[Game Id])" +
                " ,[Is Advanced] = CASE WHEN [Game Type]='Advanced' THEN 1 ELSE 0 END " +
                " FROM Games " +
                " WHERE Title LIKE '%" + DbClean(Srch) + "%' " +
                " ORDER BY Title"));
        for (var i = 0; i < dg.Columns.length; i++) dg.Columns[i].Style = "font-size:75%";

        dg.cat = CreateCategory();
        dg.Columns["Is Advanced"].Visible = false;
        dg.Columns["Game ID"].Visible = false;
        dg.Columns["Title"].HeadingAlign = 'left';
        dg.Columns["Title"].RenderText = function () {

            var gameId = dg.Columns[0].GetValue();

            var gameLink =
                '<a target="_blank" href="/story/'
                + URLEncode(this.GetValue())
                + '.aspx">'
                + ((this.GetValue()) ? (this.GetValue()) : "(no title)")
                + '</a>';

            var adminLink =
                '<a href="#" onClick="'
                + GameAdminPopupLink(gameId)
                + ';return false;">[admin]</a>';

            var editLink =
                '<a href="'
                + '/my/adveditor/?' + gameId
                + '">[edit]</a>';

            var deleteLink =
                '<a'
                + ' onclick="return ((confirm(\'Are you sure you want to permanently delete this game?\'))&&(confirm(\'Are you really, really sure?\')));"'
                + ' href="/admin/deleteGame.asp?id=' + gameId
                + '&target=' + Server.URLEncode(
                    Request.ServerVariables("PATH_INFO")
                    + "?" + Request.QueryString()
                ) + '"'
                + '>[delete]</a>';

            return gameLink
                + '<br>'
                + '<span style="font-size:75%">'
                + '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'
                + '&nbsp;&nbsp;&nbsp;' + adminLink
                + '&nbsp;&nbsp;&nbsp;' + editLink
                + '&nbsp;&nbsp;&nbsp;' + deleteLink
                + '</span>';

        }
        dg.Columns["Username"].RenderText = function () {
            return '<a href="/Member/?Username=' + dg.Columns[2].GetValue() + '">'
                + dg.Columns[2].GetValue()
                + '</a>';
        }

        dg.Columns["Category"].RenderText = function () {
            dg.cat.Load(this.GetValue()); return dg.cat.Name;
        }

        dg.OldWriteRow = dg.WriteRow;
        dg.WriteRow = function () {
            if (dg.Columns["F"].GetValue() == "Y") {
                dg.BgColor = "#eeffff";
                dg.AlternatingBgColor = "#d9eaea";
            } else if (dg.Columns["P"].GetValue() == "Y") {
                dg.BgColor = "#ffffee";
                dg.AlternatingBgColor = "#eaead9";
            } else {
                dg.BgColor = "#ffffff";
                dg.AlternatingBgColor = "#eaeaea";
            }
            dg.OldWriteRow();
        }

        return dg;

    }
</script>
<%

CheckHeader "AllGames.aspx"
	If Not IsInRole("Site Administrator") Then Response.Redirect("/")

	Dim Conn
	  Set Conn = Server.CreateObject("ADODB.Connection")
	  Conn.Open Application("ConnectionString")

	Dim dg
	  If Len(Request.QueryString())>0 Then _
  	    Set dg = CreateDataGrid(Conn,Request.QueryString("Title"))

%>

<h1>Administration &raquo; All Games</h1>

<div id="mainContent">
    <form method="get">
        <label>Game Name:</label>
        <input type="text" name="Title" value="<%=Server.HTMLEncode(Request.Querystring("Title"))%>">
        <input type="submit" value="Get Games">
    </form>
    <p class="padding:3px; smallerText"><b>Legend:</b> <b>M</b>aturity | <b>D</b>ifficulty | Is Category <b>F</b>eatured | Is <b>P</b>ublished | Page <b>C</b>ount </p>
    <% If IsObject(dg) Then dg.Display %>
</div>
<% Server.Execute(Application("SiteRoot") & "Includes/footer.asp") %>
<% Conn.Close() %>