<% option explicit
    response.buffer = true
   'on error resume next

'''''''''''''''''''''''''''
' MyAdventureGame.com       
' Constants Include
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' 
' DESCRIPTION
' This include contains all of the constants used throughout MyADventureGame.com
' and a few commonly used functions
' 
' HISTORY
' ...v0.0.1 - 2002/06/11...
' used constants.inc, reformated
' ...v0.0.2 - 2002/06/13...
' Added user level constants
' ...v0.0.3 - 2002/07/10...
' Added new link-level constants
' ...v0.0.4 - 2003/03/09
' Added message level constant IS_DELETED
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''    
    
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' GAME CATEGORIES
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	'eventually these should be moved into a table
	const   MODERN_ADVENTURE = 1
	const   FANTASY_ADVENTURE = 2
	const   SCIFI_ADVENTURE = 3
	const   SCHOOL_RELATED = 4
	const   MYSTERY_PUZZLE = 5
	const   EVERYTHING_ELSE = 6
	const	EDUTAINMENT = 7
	const	DATING_GAMES = 8



'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' BITMAP PREFERENCES
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	'picture related
	const FLOAT_PICTURE=512

	'game related
	const	IS_READY = 1
	const	IS_CLASSIC = 4
	const   IS_FEATURED = 64
	const   IS_CATEGORY_FEATURED = 128
	const   IS_HUMOROUS = 256

	'page related
	const 	HAS_OBJECTS = 2

	'link related
	const   IS_VISIBLE = 8
	const   VALID_LINK = 16
	const   SCORE_MULTIPLE = 32
	const	DISALLOW_OBJECT = 64

	'comment related
	 const	COMMENT_DELETED = 1

	 'message related
	 const	MESSAGE_DELETED = 1

	'user related
	 const	ALLOW_SNEAK_PREVIEW = 2
	 const	ALLOW_EMAIL = 4
	 const	IS_MALE = 1
	 const	STOP_NOTIFICATION = 16


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' GENGINE CONSTANTS
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	'Link Action Related Constants
	const   DELETE_LINK = -1
	const   PREVIOUS_PAGE = -2
	const   RESET_GAME = 0
	const   END_GAME = -3
	
	'chapter offeset for links
	const   CHAPTER_OFFSET = -1024

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' MISC
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	'depricated
	const   FILE_BASE = "http://www.myadventuregame.com/"

	'userid has superman access
	const   SUPERMAN = 57

	'database string
	'const DB_CONN = "DSN=MyAdventureGame;uid=myadvent;pwd=q9ck7fja"
	function DB_CONN
		DB_CONN = "Driver={SQL Server};Server=localhost;Database=myAdventureGame;Uid=MyAdventureGame;Pwd=genisis12fortune"

		'response.write "MyAdventureGame.com is undergoing routine maintenance.  Please come back in about 30 minutes!"
		'response.end
	end function




function Clean( s )
	
	Clean = Trim(Replace(Replace(s,"""","&#34;"),"'","''"))
	
end function

function DbClean(s)
	DbClean = Replace(s,"'","''")
end function

function AddHTML( s )
   
        AddHTML = Replace(s,vbCrLf,"<br>")

end function

function RemoveHTML( s )
   
        RemoveHTML = Replace(Replace(Replace(s,"<br>",vbCrLf),"<","&lt;"),">","&gt;")

end function

function ITE(cond, tru, fals)
    on error resume next
    ITE = fals
	
	if ( eval(cond) ) then
	  if (err.number = 0) then ITE = tru
	end if

end function

function SumList( list )
    dim arr, i, ret
	ret = 0
	arr = split(list,",",-1)
	for i = 0 to ubound(arr)
	 ret = ret + int(arr(i))
	next
    SumList = ret
end function
%>
