<%@ Page Language="C#" AutoEventWireup="true" Title="Advanced Editor" %>
<%@ Register TagPrefix="cys" 
    Namespace="ChooseYourStory.Web.Controls"
    Assembly="ChooseYourStory" %>
<asp:Content ContentPlaceHolderID="HeaderContentPlaceHolder" runat="server">
<script src="common.js"></script>
<script>

function validate(frm)
{

	//check the variable
	document.mainForm.Variable.value = document.mainForm.Variable.value.toUpperCase();
	if (!(checkFormat(document.mainForm.Variable.value))) return false;
	
	//check the min/max/default
	var minValue;
	if (document.mainForm.MinValue.value!='')
	{
		minValue = parseInt(document.mainForm.MinValue.value);
		if (isNaN(minValue))
		{
			alert('Minimum Value must be an integer (-5, 25, 992, etc.)');
			return false
		}
	}

	var maxValue;
	if (document.mainForm.MaxValue.value!='')
	{
		maxValue = parseInt(document.mainForm.MaxValue.value);
		if (isNaN(maxValue))
		{
			alert('Maximum Value must be an integer (-5, 25, 992, etc.)');
			return false
		}
		
		if ( (minValue) && (minValue >= maxValue) )
		{
			alert('Maximum Value must be greater than Minimum Value');
			return false;
		}
	}
	
	var defaultValue;
	if (document.mainForm.DefaultValue.value!='')
	{
		defaultValue = parseInt(document.mainForm.DefaultValue.value);
		if (isNaN(defaultValue))
		{
			alert('Default Value must be an integer (-5, 25, 992, etc.)');
			return false
		}
		
		if ( (minValue) && (minValue > defaultValue) )
		{
			alert('Default value cannot be less than the Minimum Value');
			return false;
		}
		
		if ( (maxValue) && (maxValue < defaultValue) )
		{
			alert('Default value cannot be greater than the Maximum Value');
			return false;
		}		
	}

	if (document.mainForm.AboveEventTrigger.value=='')
	{
		if (document.mainForm.AboveEventDestinationPageId.selectedIndex>0)
		{
			alert('If you select a destination page, you must specify an Above value');
			return false;
		}
	}
	else
	{
		if (isNaN(parseInt(document.mainForm.AboveEventTrigger.value)))
		{
			alert('Above Value must be an integer (-5, 25, 992, etc.)');
			return false
		}		
		if (document.mainForm.AboveEventDestinationPageId.selectedIndex<1)
		{
			alert('If you enter an Above value, you must specify a destination page.');
			return false;
		}
	}
	

	if (document.mainForm.BelowEventTrigger.value=='')
	{
		if (document.mainForm.BelowEventDestinationPageId.selectedIndex>0)
		{
			alert('If you select a destination page, you must specify a Below value');
			return false;
		}
	}
	else
	{
		if (isNaN(parseInt(document.mainForm.BelowEventTrigger.value)))
		{
			alert('Above Value must be an integer (-5, 25, 992, etc.)');
			return false
		}		
		if (document.mainForm.BelowEventDestinationPageId.selectedIndex<1)
		{
			alert('If you enter a Below value, you must specify a destination page.');
			return false;
		}
	}
	
	return true;
}



function renameVariable()
{
	var varName = document.mainForm.Variable.value;
	var newVarName = varName;
	if (!(confirm(
			'Although links using this variable will be updated with\n' 
			+ ' the new name, any text boxes containing the variable\n'
			+ ' (e.g., %%'+varName+'%%) will not be, causing a 0 to be always\n'
			+ 'be displayed instead of the intended value.\n\n'
			+ 'Are you absolutely sure you want to rename your variable?'))) return false;
	
	while (true)
	{
		newVarName = prompt('Enter a new name for the variable:',newVarName);
		if (newVarName==null) return;
		newVarName = newVarName.toUpperCase();
		if (checkFormat(newVarName)) break;
	}

	document.mainForm.NewVariable.value = newVarName;
	PostBack('renamevariable',varName);	
}


function checkFormat(varName)
{
	if (/^[A-Z][A-Z0-9]{0,9}$/.exec(varName))
	{
		return true
	}
	else
	{		
		alert('The name of the variable you entered was not valid. Variables must \n'
				+ ' - have 1-10 characters\n'
				+ ' - be in ALL CAPS\n'
				+ ' - contain letters (A-Z) and numbers (0-9) only\n'
				+ ' - have a letter as the first character');
		return false;
	}
}


</script>
</asp:Content>
<asp:Content ContentPlaceHolderID="MainContentPlaceHolder" Runat="Server">
    <cys:AspPage runat="server" Url="variable.asp" CopyQueryString="true" CopyForm="true" />
</asp:Content>