<% Option Explicit %>
<!-- #include file="../../Includes/Request_Start.inc.asp" -->
<script runat="server" language="vbscript" src="../../Includes/gameValidator.vbs"></script>
<%

Dim ItemRestrictions
ItemRestrictions = Array("Has", "Not Has")

Dim GameID, LinkId
GameID = CLng(Request.QueryString("GameId"))
LinkId = CLng(Request.QueryString("LinkId"))

Dim variableLevel
With Server.CreateObject("ADODB.Command")
	.ActiveConnection = Application("ConnectionSTring")
	.CommandText = "ChooseYourStory.dbo.Story_Editing_GetEditorOptions"
	.CommandType = adCmdStoredProc
	.Parameters.Append .CreateParameter("@StoryId",adInteger,adParamInput,4,GameId)
	.Parameters.Append .CreateParameter("@User_Username",adVarChar,adParamInput,30,Session("Username"))
	With .Execute
		variableLevel = .Fields("Variable_Level")
	End With
End With

Dim Conn : Set Conn = Server.CreateObject("ADODB.Connection")
 Conn.Open Application("ConnectionString")
ValidateGameWithConn GameID, Conn

If Not IsEmpty(Request.Form("_save")) Then Save

Sub Save
	Dim Element

	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Conn
		.CommandText = _
			"UPDATE [Game Links] SET [Visible When Inactive]=?, [Maximum Uses]=? " & _
			" WHERE [Game Id] = ? AND [Link Id] = ?"
		.Parameters.Append .CreateParameter("Visible When Inactive",adInteger,adParamInput,4,Not IsEmpty(Request.Form("Visible When Inactive")))
		If Request.Form("Maximum Uses") = "" Then
			.Parameters.Append .CreateParameter("Maximum Uses",adInteger,adParamInput,4,Null)
		Else
			.Parameters.Append .CreateParameter("Maximum Uses",adInteger,adParamInput,4,Request.Form("Maximum Uses"))
		End If
		.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameID)
		.Parameters.Append .CreateParameter("LinkId",adInteger,adParamInput,4,LinkId)
		.Execute
	End With

	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Conn
		.CommandText = "DELETE FROM [Game Link Variable Restrictions] WHERE [Game Id] = ? AND [Link Id] = ?"
		.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameID)
		.Parameters.Append .CreateParameter("LinkId",adInteger,adParamInput,4,LinkId)
		.Execute
	End With

	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Conn
		.CommandText = _
			"INSERT INTO [Game Link Variable Restrictions] ([Game ID], [Link Id], [Variable], [RestrictionType_Code], [Restriction_Value], [Or_Indicator], [Not_Indicator]) " & _
			"VALUES (?, ?, ?, ?, ?, ?, ?) "
		.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,8,GameID)
		.Parameters.Append .CreateParameter("LinkId",adInteger,adParamInput,8,LinkId)
		.Parameters.Append .CreateParameter("Variable",adVarChar,adParamInput,10)
		.Parameters.Append .CreateParameter("RestrictionType_Code",adChar,adParamInput,2)
		.Parameters.Append .CreateParameter("Restriction_Value",adVarChar,adParamInput,500)
		.Parameters.Append .CreateParameter("Or_Indicator",adChar,adParamInput,1)
		.Parameters.Append .CreateParameter("Not_Indicator",adChar,adParamInput,1)

		For Each Element In Request.Form
			Dim Variable, rType, rValue, rValue2
			'Each Var is in a (v_VARNAME_type, v_VARNAME_val, v_VARNAME_val2) set
			If (Left(Element,2) = "v_") And (Right(Element,5)="_type") Then
				'Extract components
				Variable = Mid(Element, 3, Len(Element) - 7)
				rType = Request.Form("v_" & Variable &  "_type")
				rValue = Request.Form("v_" & Variable & "_val")
				rValue2 = Request.Form("v_" & Variable & "_val2")

				'special handling based on type selected
				If rType = "XX" Then
					If cleanVar(rValue)="" And cleanVar(rValue2)="" Then
						rType = Null : rValue = Null
					ElseIf cleanVar(rValue)="" Then
						rType = "LE"
						rValue = cleanVar(rValue2)
					ElseIf cleanVar(rValue2)="" Then
						rType = "GE"
						rValue = cleanVar(rValue)
					Else
						rType = "BT"
						rValue = cleanVar(rValue) & "," & cleanVar(rValue2)
					End If
				ElseIf rType="" Then
					rType = Null : rValue = Null
				ElseIf rType = "BT" Then
					'Between can only be "VAR,VAR2"
					If cleanVar(rValue)="" Or cleanVar(Request.Form("v_" & Variable & "_val2"))="" Then
						rValue = Null : rType = Null
					Else
						rValue = cleanVar(rValue) & "," & cleanVar(Request.Form("v_" & Variable & "_val2"))
					End If
				ElseIf rType = "IN" Then
					rValue = cleanVarList(rValue)
					If rValue = "" Then
						rValue = Null : rType = Null
					End If
				Else
					If cleanVar(rValue)="" Then
						rValue = Null : rType = Null
					Else
						rValue = cleanVar(rValue)
					End If
				End If
				If Not IsNull(rType) Then
					.Parameters("Variable").Value = Variable
					.Parameters("RestrictionType_Code").Value = rType
					.Parameters("Restriction_Value").Value = rValue
					.Parameters("Or_Indicator").Value = IIf(Request.Form("v_" & Variable & "_or")="Y","Y","N")
					.Parameters("Not_Indicator").Value  = IIf(Request.Form("v_" & Variable & "_not")="Y","Y","N")
					.Execute
				End If
			End If
		Next
	End With

	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Conn
		.CommandText = "DELETE FROM [Game Link Item Restrictions] WHERE [Game Id] = ? AND [Link Id] = ?"
		.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameID)
		.Parameters.Append .CreateParameter("LinkId",adInteger,adParamInput,4,LinkId)
		.Execute
	End With

	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Conn
		.CommandText = _
			"INSERT INTO [Game Link Item Restrictions] ([Game ID], [Link Id], [Item Id], [Item Restriction]) " & _
			"VALUES (?, ?, ?, ?) "
		.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,8,GameID)
		.Parameters.Append .CreateParameter("LinkId",adInteger,adParamInput,8,LinkId)
		.Parameters.Append .CreateParameter("ItemId",adInteger,adParamInput,8)
		.Parameters.Append .CreateParameter("ItemRestriction",adVarChar,adParamInput,10)
		For Each Element In Request.Form
			Dim ItemId
			'Each Item is i_ITEMID with a value of the restriction type
			If (Left(Element,2) = "i_") And (Request.Form(Element)<>"") Then
				ItemId = Right(Element, Len(Element) - 2)
				.Parameters("ItemId").Value = CLng(ItemId)
				.Parameters("ItemRestriction").Value = Request.Form(Element)
				.Execute
			End If
		Next
	End With

	If InStr(Request.Form("_save"),"Close")>0 Then
		Conn.Close
		%><script>
		    var win = ( (window.dialogArguments) ? (window.dialogArguments) : (window.opener) );
			win.btn_save_changes.click();
		    window.close();
		  </script>This window may be closed.<%
		Response.End
	End If
End Sub

%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
    <title>Link Restrictions</title>
    <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
    <link href="/App_Themes/CYS/styles.css" rel="stylesheet" type="text/css">
    <base target="MAG_editRestrictions">
    <script>

function select(el)
{
	document.getElementById("linkOptionSelected").style.display = 'none';
	document.getElementById("linkOption").style.display = 'inline';
	document.getElementById("variableOptionSelected").style.display = 'none';
	document.getElementById("variableOption").style.display = 'inline';
	document.getElementById("itemOptionSelected").style.display = 'none';
	document.getElementById("itemOption").style.display = 'inline';

	document.getElementById("link").style.display = 'none';
	document.getElementById("variable").style.display = 'none';
	document.getElementById("item").style.display = 'none';

	document.getElementById(el).style.display = 'block';
	document.getElementById(el+"OptionSelected").style.display = 'inline';
	document.getElementById(el+"Option").style.display = 'none';
}

function selectRestrictionType(sel,variable)
{
	var type = sel.options[sel.selectedIndex].value;
	var frm = sel.form;
	document.getElementById("v_"+variable+"_BT").style.display = (type=="BT")?"inline":"none";
	frm.elements["v_"+variable+"_val"].size = (type=="BT")?5:10;
	frm.elements["v_"+variable+"_val"].disabled = (type=="");
	frm.elements["v_"+variable+"_val"].maxLength = (type=="IN")?500:10;
	if (type!="IN") frm.elements["v_"+variable+"_val"].value = frm.elements["v_"+variable+"_val"].value.substring(0,10);
}

window.name = "MAG_editRestrictions";
</script>
</head>
<body>
    <form target="MAG_editRestrictions" method="post">
        <div style="padding: 15px; width: 450px; padding-top: 0px;">
            <h1 style="margin-bottom: 0px;">Link Restrictions</h1>
            <p class="smallerText" style="margin-top: 0px;">
                The following rules are used to determine whether or not
   the link will be displayed.
                <br />
                <strong>Item Restrictions</strong> allow you to restrict
   players based on their inventory.<br />
                <% If variableLevel <> "Disabled" Then %>
                <strong>Variable Restrictions</strong> allow you to restrict
		players based on values of variables.
                <br />
                <% End If %>
            </p>

            <table style="margin: 5px 0px 5px 0px" cellpadding="5" cellspacing="0" border="0">
                <tr>
                    <td style="border: 1px solid black; padding: 3px; padding-left: 0px; border-left-width: 0px;">
                        <span id="linkOptionSelected" class="tertiaryButtonSelected">Link Options</span>
                        <span id="linkOption" class="tertiaryButton" style="cursor: pointer; display: none;" onclick="select('link');">Link Options</span>
                        |

                        <% If variableLevel <> "Disabled" Then %>
                        <span id="variableOptionSelected" style="display: none;" class="tertiaryButtonSelected">Variable Restrictions</span>
                        <span id="variableOption" class="tertiaryButton" style="cursor: pointer" onclick="select('variable');">Variable Restrictions</span>
                        |

                        <% Else %>
                        <span id="variableOptionSelected"></span>
                        <span id="variableOption"></span>
                        <% End If %>
                        <span id="itemOptionSelected" style="display: none;" class="tertiaryButtonSelected">Item Restrictions</span>
                        <span id="itemOption" class="tertiaryButton" style="cursor: pointer;" onclick="select('item');">Item Restrictions</span>
                    </td>
                </tr>
            </table>
            <div id="link">
                <%
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Conn
		.CommandText = _
			"SELECT [Visible When Inactive], [Maximum Uses]"  & _
			"  FROM [Game Links] " & _
			" WHERE [Game Id] = ? AND [Link Id] = ? "
		.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameID)
		.Parameters.Append .CreateParameter("LinkId",adInteger,adParamInput,4,LinkId)
		With .Execute
%>
                <p>
                    <input type="checkbox" value="true" name="Visible When Inactive" <%If .Fields("Visible When Inactive") Then Response.WRite " checked"%>>&nbsp;<label>Visible When Inactive</label><br />
                    <span class="smallerText">Indicates if the link should be displayed if it is restricted</span>
                </p>
                <p style="margin-top: 5px;">
                    <select name="Maximum Uses" class="smallerText">
                        <option value="">No Limit</option>
                        <% Dim i : For i = 1 To 50
	Response.Write  "<option value=""" & i & """ "
	If i = .Fields("Maximum Uses") Then Response.Write  "selected=""true"""
	Response.Write ">" & i & "</option>"
   Next
%>
                    </select>
                    <label>Maximum Number of Uses</label><br />
                    <span class="smallerText">The number of times the player can click on the link throughout the entire game</span>
                </p>
                <%
		End With
	End With
%>
            </div>
            <div id="variable" style="display: none; overflow: auto; height: 220px;">
                <table border="0" cellspacing="5" cellpadding="0">
                    <tr>
                        <% If variableLevel = "Advanced" Then %>
                        <th>Variable</th>
                        <th>Type</th>
                        <th>Value</th>
                        <th>Or</th>
                        <th>Not</th>
                        <% End If %>
                    </tr>
                    <%
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Conn
		.CommandText = _
			"SELECT V.[Variable], VR.[Minimum], VR.[Maximum], VR.[RestrictionType_Code], " & _
			"       COALESCE(VR.[Restriction_Value],'') [Restriction_Value], " & _
			"       [Or_Indicator], [Not_Indicator] " & _
			"  FROM [Game Variables] V " & _
			"       LEFT JOIN [Game Link Variable Restrictions] VR " & _
			"               ON V.[GAme Id] = VR.[Game Id] " & _
			"              AND V.[Variable] = VR.[Variable] " & _
			"              AND VR.[Link Id] = ? " & _
			" WHERE V.[Game Id] = ? " & _
			" ORDER BY V.[Variable] "
		.Parameters.Append .CreateParameter("LinkId",adInteger,adParamInput,4,LinkId)
		.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameID)
		With .Execute
			Do While Not .EOF
				Response.Write "<tr>"
				''' VAR NAME '''
				Response.Write "<td style='font-weight:bold;'>" & .Fields("Variable") & "</td>"

				If variableLevel = "Advanced" Then
					''' TYPE '''
					Response.Write "<td><select name=""v_" & .Fields("Variable") & "_type"" onChange=""selectRestrictionType(this,'" & .Fields("Variable") & "')"">" & _
						"<option value="""">(none)</option>" & _
						"<option value=""BT""" & _
							selectedIf(.Fields("RestrictionType_Code")="BT") & _
							">Between</option>" & _
						"<option value=""EQ""" & _
							selectedIf(.Fields("RestrictionType_Code")="EQ") & _
							">=</option>" & _
						"<option value=""GT""" & _
							selectedIf(.Fields("RestrictionType_Code")="GT") & _
							">&gt;</option>" & _
						"<option value=""LT""" & _
							selectedIf(.Fields("RestrictionType_Code")="LT") & _
							">&lt;</option>" & _
						"<option value=""GE""" & _
							selectedIf(.Fields("RestrictionType_Code")="GE") & _
							">&gt;=</option>" & _
						"<option value=""LE""" & _
							selectedIf(.Fields("RestrictionType_Code")="LE") & _
							">&lt;=</option>" & _
						"<option value=""IN""" & _
							selectedIf(.Fields("RestrictionType_Code")="IN") & _
							">In List</option>" & _
						"</select></td>"
					Response.Write "<td>"

					''' VALUE '''
					Dim rVal, rVal2
					rVal = .Fields("Restriction_Value")
					If .Fields("RestrictionType_Code")="BT" Then
						If UBound(Split(.Fields("Restriction_Value"),",")) = 1 Then
							rVal = Split(.Fields("Restriction_Value"),",")(0)
							rval2 = Split(.Fields("Restriction_Value"),",")(1)
						End If
					End If
					Response.Write "<input type=""text""" & _
						" name=""v_" & .Fields("Variable") & "_val""" & _
						" size=""" & IIf(.Fields("RestrictionType_Code")="BT","5","10") & """ " & _
						Iif(IsNull(.Fields("RestrictionType_Code"))," disabled ","") & _
						" maxlength=""" & IIf(.Fields("RestrictionType_Code")="IN",500,10) & """  " & _
						" value=""" & rVal & """>"
					Response.Write "<span id=""v_" & .Fields("Variable") & "_BT""" & _
						displayNoneIf(.Fields("RestrictionType_Code")<>"BT" Or IsNull(.Fields("RestrictionType_Code"))) & _
						">&nbsp;and&nbsp;<input maxlength=""10"" size=""10"" type=""text""" & _
						" name=""v_" & .Fields("Variable") & "_val2""" & _
						" value=""" & rVal2 & """></span>"
					Response.Write "</td>"

					''' OR '''
					Response.Write "<td><input type=""checkbox""" & _
						IIf(.Fields("Or_Indicator")="Y"," checked ","") & _
						" name=""v_" & .Fields("Variable") & "_or"" value=""Y"" /></td>"

					''' NOT '''
					Response.Write "<td><input type=""checkbox""" & _
						IIf(.Fields("Not_Indicator")="Y"," checked ","") & _
						" name=""v_" & .Fields("Variable") & "_not"" value=""Y"" /></td>"
				Else
					Response.Write "<td class=""smallerText"">"
						Response.Write "<input type=""hidden"" name=""v_" & .Fields("Variable") & "_type"" value=""XX"" />"

						If .Fields("RestrictionType_Code")="BT" Then
							If UBound(Split(.Fields("Restriction_Value"),",")) >= 1 Then
								rVal = Split(.Fields("Restriction_Value"),",")(0)
								rval2 = Split(.Fields("Restriction_Value"),",")(1)
							End If
						ElseIf .Fields("RestrictionType_Code")="GE" Then
							rVal = .Fields("Restriction_Value")
							rVal2 = ""
						ElseIf .Fields("RestrictionType_Code")="LE" Then
							rVal = ""
							rVal2 = .Fields("Restriction_Value")
						Else
							rVal = ""
							rVal2 = ""
						End If

						Response.Write " is between "
						''' VALUE '''
						Response.Write "<input type=""text""" & _
							" name=""v_" & .Fields("Variable") & "_val"" size=""5"" " & _
							" maxlength=""10""  " & _
							" value=""" & rVal & """>"
						Response.Write " and "
						Response.Write "<input maxlength=""10"" size=""5"" type=""text""" & _
							" name=""v_" & .Fields("Variable") & "_val2""" & _
							" value=""" & rVal2 & """>"
					Response.Write "</td>"
				End If
				.MoveNext
			Loop
		End With
	End With
%>
                </table>
                <% If variableLevel = "Advanced" Then %>
                <p class="smallerText">
                    <b>Variable - </b>the used to restrict the link<br />
                    <b>Type - </b>how the Variable should be compared against the Value. "Between" is
		inclusive (e.g. 3 is between 3 and 5) and "In List" means that the Variable must be
		one of the specified Values.<br />
                    <b>Value - </b>must either a valid number (-22, 8, 0, etc) or a variable name (HEALTH, SCORE, etc). When
	 using "In List", a comma-separated list of numbers or variables can
	 be entered. Eg: "22,SCORE,18,-4,0"<br />
                    <b>Or - </b>the link will not be restricted if the condition is met or if all other conditions are met<br />
                    <b>Not - </b>the opposite of the condition is required to enable the link
                    <br />
                    Note: Invalid input will always be converted to valid input (even if it means deleting the restriction), so if
	 you are unsure, just click the Save button and see what happens.
                </p>
                <% Else %>
                <p class="smallerText">
                    <strong>Note:</strong> Leave blank to indicate no restriction.<br />
                </p>
                <% End If %>
            </div>

            <div id="item" style="display: none; overflow: auto; height: 220px;">

                <table border="0" cellspacing="2" cellpadding="0">
                    <tr>
                        <th align="left">Item</th>
                        <th>&nbsp;</th>
                        <th align="left">Restriction</th>
                    </tr>
                    <%
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Conn
		.CommandText = _
			"SELECT I.[Item Id], I.[Title], IR.[Item Restriction] " & _
			"  FROM [Game Items] I " & _
			"       LEFT JOIN [Game Link Item Restrictions] IR " & _
			"               ON I.[Game Id] = IR.[Game Id] " & _
			"              AND I.[Item Id] = IR.[Item ID] " & _
			"              AND IR.[Link Id] = ? " & _
			" WHERE I.[Game Id] = ? " & _
			" ORDER BY CASE WHEN IR.[Item Restriction] IS NULL THEN 1 ELSE 0 END, I.[Title], I.[Item Id] "
		.Parameters.Append .CreateParameter("LinkId",adInteger,adParamInput,4,LinkId)
		.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameID)
		With .Execute
			Do While Not .EOF
				Response.Write "<tr>"
				Response.Write "<td>" & .Fields("Title") & "</td>"
				Response.Write "<td>&nbsp;</td>"
				Response.Write "<td><select " & _
								" name=""i_" & .Fields("Item Id") & """>"
				Response.Write "<option value="""">None</option>"
				For i = 0 To UBound(ItemRestrictions)
					Response.Write "<option value=""" & ItemRestrictions(i) & """"
					If .Fields("Item Restriction") = ItemRestrictions(i) Then _
						Response.Write " selected=""true"" style=""color:red"""
					Response.Write ">" & ItemRestrictions(i) & "</option>"
				Next
				Response.Write "</select></td>"
				.MoveNext
			Loop
		End With
	End With
%>
                </table>
            </div>

            <p>
                <input type="submit" name="_save" value="Save & Close Window" class="smallerText">
                &nbsp;

                <input type="submit" name="_save" value=" Save " class="smallerText">
            </p>
            <p class="smallerText">
                <% If variableLevel = "Basic" Then %>
		Need more options? Change your <em>Variable Level</em> to <em>Advanced</em> on the Storygame Properties page.

                <% ElseIf variableLevel = "Advanced" Then %>
		Too many options? Change your <em>Variable Level</em> to <em>Basic</em> on the Storygame Properties page.

                <% Else %>
		Need more options? Change your <em>Variable Level</em> to <em>Basic</em> on the Storygame Properties page.

                <% End If %>
            </p>
        </div>
    </form>
</body>
</html>
<% Conn.Close

Function selectedIf(condition)
	If condition Then selectedIf = " selected "
End Function

Function displayNoneIf(condition)
	If condition Then displayNoneIf = " style=""display:none"" "
End Function

Function IIf(condition,t,f)
	If condition Then IIf = t Else IIf = f
End Function

Function cleanVar(s)
	cleanVar = ""
	s = UCase(s) 'vars always caps
	Dim ch,i : i = 0
	Do While i < Len(s) And Len(cleanVar) < 10
		i = i + 1 : ch = Mid(s,i,1)
		If (Asc(ch) >= Asc("A") And Asc(ch) <= Asc("Z")) _
			Or (Asc(ch) >= Asc("0") And Asc(ch) <= Asc("9")) _
			Or (ch="-") Then cleanVar = cleanVar & ch
	Loop
	'vars must begin with letter, if first letter is numeric, convert to number
	If cleanVar<>"" Then
		If IsNumeric(Mid(cleanVar,1,1)) Or Mid(cleanVar,1,1)="-" Then
			cleanVar = Val(cleanVar)
		Else
			cleanVar = Replace(cleanVar,"-","")
		End If
	End If
End Function

Function cleanVarList(s)
	cleanVarList = ""
	Dim i, cv, ary : ary = Split(s,",")
	For i = 0 To UBound(ary)
		cv = cleanVar(ary(i))
		If cv<>"" Then
			If cleanVarList<>"" Then cleanVarList = cleanVarList & ","
			cleanVarList = cleanVarList & cv
		End If
	Next
End Function

Function Val(s)
	i = 1
	Do
		If i > Len(s) Then Exit Do
		If Not (IsNumeric(Mid(s, i, 1)) Or (Mid(s, i, 1)="-" And i=1)) Then Exit Do
		i = i + 1
	Loop
	Val = Left(s, i - 1)
	If Val="-" Then Val=""
End Function

%>